﻿
Public Class dll_comm
  ' Exported DLL functions - x86
  Private Declare Function GetRGBDevice_x86 Lib "slma.dll" Alias "GetRGBDevice" () As Integer
  Private Declare Function GetRGBDeviceSerial_x86 Lib "slma.dll" Alias "GetRGBDeviceSerial" (ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
  Private Declare Function GetRGBDeviceLocation_x86 Lib "slma.dll" Alias "GetRGBDeviceLocation" (ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
  Private Declare Function GetRGBFirmwareVersion_x86 Lib "slma.dll" Alias "GetRGBFirmwareVersion" (ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
  Private Declare Function SetRGBStatus_x86 Lib "slma.dll" Alias "SetRGBStatus" (ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
  Private Declare Function SetRGBStatusOnPower_x86 Lib "slma.dll" Alias "SetRGBStatusOnPower" (ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
  Private Declare Function GetRGBStatus_x86 Lib "slma.dll" Alias "GetRGBStatus" (ByVal DevIdx As Integer, ByRef Red As Integer, ByRef Green As Integer, ByRef Blue As Integer) As Integer
  Private Declare Function GetLibVersion_x86 Lib "slma.dll" Alias "GetLibVersion" (ByRef Major As Integer, ByRef Minor As Integer) As Integer
  ' Exported DLL functions - x64 
  Private Declare Function GetRGBDevice_x64 Lib "slma_x64.dll" Alias "GetRGBDevice" () As Integer
  Private Declare Function GetRGBDeviceSerial_x64 Lib "slma_x64.dll" Alias "GetRGBDeviceSerial" (ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
  Private Declare Function GetRGBDeviceLocation_x64 Lib "slma_x64.dll" Alias "GetRGBDeviceLocation" (ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
  Private Declare Function GetRGBFirmwareVersion_x64 Lib "slma_x64.dll" Alias "GetRGBFirmwareVersion" (ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
  Private Declare Function SetRGBStatus_x64 Lib "slma_x64.dll" Alias "SetRGBStatus" (ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
  Private Declare Function SetRGBStatusOnPower_x64 Lib "slma_x64.dll" Alias "SetRGBStatusOnPower" (ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
  Private Declare Function GetRGBStatus_x64 Lib "slma_x64.dll" Alias "GetRGBStatus" (ByVal DevIdx As Integer, ByRef Red As Integer, ByRef Green As Integer, ByRef Blue As Integer) As Integer
  Private Declare Function GetLibVersion_x64 Lib "slma_x64.dll" Alias "GetLibVersion" (ByRef Major As Integer, ByRef Minor As Integer) As Integer


  Private Shared Function IsX86() As Boolean
    If IntPtr.Size() = 4 Then
      Return True
    Else
      Return False
    End If

  End Function


  Public Shared Function GetRGBDevice() As Integer
    If IsX86() = True Then
      Return GetRGBDevice_x86
    Else
      Return GetRGBDevice_x64
    End If
  End Function

  Public Shared Function GetRGBDeviceSerial(ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
    If IsX86() = True Then
      Return GetRGBDeviceSerial_x86(DevIdx, TypeCode, BatchCode, SerialCode)
    Else
      Return GetRGBDeviceSerial_x64(DevIdx, TypeCode, BatchCode, SerialCode)
    End If
  End Function

  Public Shared Function GetRGBDeviceLocation(ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
    If IsX86() = True Then
      Return GetRGBDeviceLocation_x86(DevIdx, Loc)
    Else
      Return GetRGBDeviceLocation_x64(DevIdx, Loc)
    End If
  End Function

  Public Shared Function GetRGBFirmwareVersion(ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
    If IsX86() = True Then
      Return GetRGBFirmwareVersion_x86(DevIdx, Major, Minor, Build)
    Else
      Return GetRGBFirmwareVersion_x64(DevIdx, Major, Minor, Build)
    End If
  End Function

  Public Shared Function SetRGBStatus(ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
    If IsX86() = True Then
      Return SetRGBStatus_x86(DevIdx, Red, Green, Blue)
    Else
      Return SetRGBStatus_x64(DevIdx, Red, Green, Blue)
    End If
  End Function

  Public Shared Function SetRGBStatusOnPower(ByVal DevIdx As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
    If IsX86() = True Then
      Return SetRGBStatusOnPower_x86(DevIdx, Red, Green, Blue)
    Else
      Return SetRGBStatusOnPower_x64(DevIdx, Red, Green, Blue)
    End If
  End Function

  Public Shared Function GetRGBStatus(ByVal DevIdx As Integer, ByRef Red As Integer, ByRef Green As Integer, ByRef Blue As Integer) As Integer
    If IsX86() = True Then
      Return GetRGBStatus_x86(DevIdx, Red, Green, Blue)
    Else
      Return GetRGBStatus_x64(DevIdx, Red, Green, Blue)
    End If
  End Function

  Public Shared Function GetLibVersion(ByRef Major As Integer, ByRef Minor As Integer) As Integer
    If IsX86() = True Then
      Return GetLibVersion_x86(Major, Minor)
    Else
      Return GetLibVersion_x64(Major, Minor)
    End If
  End Function
End Class
