﻿
Public Class dll_comm
  ' Exported DLL functions - x86
  Private Declare Function SetUsbDevice_x86 Lib "slma.dll" Alias "SetUsbDevice" () As Integer
  Private Declare Function GetDeviceSerial_x86 Lib "slma.dll" Alias "GetDeviceSerial" (ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
  Private Declare Function GetDeviceLocation_x86 Lib "slma.dll" Alias "GetDeviceLocation" (ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
  Private Declare Function GetFirmwareVersion_x86 Lib "slma.dll" Alias "GetFirmwareVersion" (ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
  Private Declare Function GetLibVersion_x86 Lib "slma.dll" Alias "GetLibVersion" (ByRef Major As Integer, ByRef Minor As Integer) As Integer
  Private Declare Function SetDeviceStatus_x86 Lib "slma.dll" Alias "SetDeviceStatus" (ByVal DevIdx As Integer, ByVal Tier1 As Char, ByVal Tier2 As Char, ByVal Tier3 As Char, ByVal Tier4 As Char, ByVal Tier5 As Char) As Integer
  Private Declare Function GetDeviceStatus_x86 Lib "slma.dll" Alias "GetDeviceStatus" (ByVal DevIdx As Integer, ByRef Tier1 As Char, ByRef Tier2 As Char, ByRef Tier3 As Char, ByRef Tier4 As Char, ByRef Tier5 As Char) As Integer

  ' Exported DLL functions - x64 
  Private Declare Function SetUsbDevice_x64 Lib "slma_x64.dll" Alias "SetUsbDevice" () As Integer
  Private Declare Function GetDeviceSerial_x64 Lib "slma_x64.dll" Alias "GetDeviceSerial" (ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
  Private Declare Function GetDeviceLocation_x64 Lib "slma_x64.dll" Alias "GetDeviceLocation" (ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
  Private Declare Function GetFirmwareVersion_x64 Lib "slma_x64.dll" Alias "GetFirmwareVersion" (ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
  Private Declare Function GetLibVersion_x64 Lib "slma_x64.dll" Alias "GetLibVersion" (ByRef Major As Integer, ByRef Minor As Integer) As Integer
  Private Declare Function SetDeviceStatus_x64 Lib "slma_x64.dll" Alias "SetDeviceStatus" (ByVal DevIdx As Integer, ByVal Tier1 As Char, ByVal Tier2 As Char, ByVal Tier3 As Char, ByVal Tier4 As Char, ByVal Tier5 As Char) As Integer
  Private Declare Function GetDeviceStatus_x64 Lib "slma_x64.dll" Alias "GetDeviceStatus" (ByVal DevIdx As Integer, ByRef Tier1 As Char, ByRef Tier2 As Char, ByRef Tier3 As Char, ByRef Tier4 As Char, ByRef Tier5 As Char) As Integer

  Private Shared Function IsX86() As Boolean
    If IntPtr.Size() = 4 Then
      Return True
    Else
      Return False
    End If

  End Function


  Public Shared Function SetUsbDevice() As Integer
    If IsX86() = True Then
      Return SetUsbDevice_x86
    Else
      Return SetUsbDevice_x64
    End If
  End Function

  Public Shared Function GetDeviceStatus(ByVal DevIdx As Integer, ByRef Tier1 As Char, ByRef Tier2 As Char, ByRef Tier3 As Char, ByRef Tier4 As Char, ByRef Tier5 As Char) As Integer
    If IsX86() = True Then
      Return GetDeviceStatus_x86(DevIdx, Tier1, Tier2, Tier3, Tier4, Tier5)
    Else
      Return GetDeviceStatus_x64(DevIdx, Tier1, Tier2, Tier3, Tier4, Tier5)
    End If
  End Function

  Public Shared Function SetDeviceStatus(ByVal DevIdx As Integer, ByRef Tier1 As Char, ByRef Tier2 As Char, ByRef Tier3 As Char, ByRef Tier4 As Char, ByRef Tier5 As Char) As Integer
    If IsX86() = True Then
      Return SetDeviceStatus_x86(DevIdx, Tier1, Tier2, Tier3, Tier4, Tier5)
    Else
      Return SetDeviceStatus_x64(DevIdx, Tier1, Tier2, Tier3, Tier4, Tier5)
    End If
  End Function

  Public Shared Function GetDeviceSerial(ByVal DevIdx As Integer, ByRef TypeCode As Integer, ByRef BatchCode As Integer, ByRef SerialCode As Integer) As Integer
    If IsX86() = True Then
      Return GetDeviceSerial_x86(DevIdx, TypeCode, BatchCode, SerialCode)
    Else
      Return GetDeviceSerial_x64(DevIdx, TypeCode, BatchCode, SerialCode)
    End If
  End Function

  Public Shared Function GetDeviceLocation(ByVal DevIdx As Integer, ByRef Loc As Integer) As Integer
    If IsX86() = True Then
      Return GetDeviceLocation_x86(DevIdx, Loc)
    Else
      Return GetDeviceLocation_x64(DevIdx, Loc)
    End If
  End Function

  Public Shared Function GetLibVersion(ByRef Major As Integer, ByRef Minor As Integer) As Integer
    If IsX86() = True Then
      Return GetLibVersion_x86(Major, Minor)
    Else
      Return GetLibVersion_x64(Major, Minor)
    End If
  End Function

  Public Shared Function GetFirmwareVersion(ByVal DevIdx As Integer, ByRef Major As Integer, ByRef Minor As Integer, ByRef Build As Integer) As Integer
    If IsX86() = True Then
      Return GetFirmwareVersion_x86(DevIdx, Major, Minor, Build)
    Else
      Return GetFirmwareVersion_x64(DevIdx, Major, Minor, Build)
    End If
  End Function
End Class
